import { hash, path, useDenaroPlugin } from '@vuepress-denaro/core';
import { mdPluginVuePreview } from './md-plugin-vue-preview/index.js';
import { prepareConfigFile } from './utils/prepareConfigFile.js';
import { PLUGIN_NAME } from './utils.js';
export const vuePreviewPlugin = (options) => useDenaroPlugin(() => {
    const { rootPath } = options || {};
    const stateOptions = {
        componentsDir: rootPath,
        componentsPatterns: ['**/*.vue'],
        getComponentName: (filename) => path.trimExt(filename.replace(/\/|\\/g, '-')),
    };
    const optionsHash = hash(stateOptions);
    return {
        name: PLUGIN_NAME,
        extendsMarkdown(md) {
            md.use(mdPluginVuePreview, { rootPath });
        },
        clientConfigFile: (app) => prepareConfigFile(app, stateOptions, optionsHash),
    };
});
